import 'package:event_bus/event_bus.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mylibrary/base/provider/view_state_model.dart';
import 'package:flutter_mylibrary/utils/win_media.dart';
import 'package:flutter_mylibrary/widget/widget_template.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'package:synchronized/synchronized.dart';


final EventBus publicEventBus = EventBus();

///全局context
GlobalKey<NavigatorState> navigatorKey = GlobalKey<NavigatorState>();

BuildContext get appContext => navigatorKey.currentState?.overlay?.context;

NavigatorState get navigatorState => navigatorKey?.currentState;

int startPage = 1;

int pageLimit = 10;

bool centerTitle = true;

double defMargin = 15;

get lock => Lock();


/// **********************************************Widget配置*************************************************************************************/

///loading
Widget get pageLoading => SpinKitWave(color: Theme.of(appContext).primaryColor, type: SpinKitWaveType.start, size: getSp(24),);

///空数据布局
ViewStateModelEmptyWidgetBuilder emptyWidget = (message, viewStateModel) => getNoDataWidget(error: message, viewStateModel: viewStateModel);

ViewStateModelErrorWidgetBuilder errorWidget = (error, viewStateModel) => getNoDataWidget(error: error, viewStateModel: viewStateModel);


/// **********************************************设置网络错误提示*************************************************************************************/
String CONNECT_TIMEOUT_MSG = "网络连接超时，请检查网络设置";
String RECEIVE_TIMEOUT_MSG = "服务器异常，请稍后重试！";
String SEND_TIMEOUT_MSG = "网络连接超时，请检查网络设置";
String HTTP_ERROR_MSG = "服务器异常，请稍后重试！";
String CANCEL_MSG = "请求已被取消，请稍后重试！";
String NO_DATA = '无数据';




/// **********************************************公用key*************************************************************************************/
const String loginKey = 'loginKey';

const String userKey = 'userKey';

const String themeKey = 'themeKey';

const kThemeUserDarkMode = 'kThemeUserDarkMode';

const kThemeColor = 'kThemeColor';


/// **********************************************EventBus公用类*************************************************************************************/
class CourseScheduleRefreshEvent {}





/// **********************************************自定义方法名*************************************************************************************/
typedef ViewStateModelWidgetBuilder<T> = Widget Function(T value);

typedef ViewStateModelWidgetListBuilder<T> = List<Widget> Function(T value);

typedef ViewStateModelEmptyWidgetBuilder = Widget Function(String message, ViewStateModel viewStateModel);

typedef ViewStateModelErrorWidgetBuilder = Widget Function(String message, ViewStateModel viewStateModel);

typedef ViewPortBuilder = void Function(int firstIndex, int lastIndex);